<template>
  <v-app>
    <v-layout justify-center style="margin-top:100px;">
      <v-flex xs10 md10 style="padding:60px;">
        <v-card class="mx-auto" elevation="1" style="height:auto;">
          <!-- --------------------- Reconcile -------------------------  -->
          <v-container>
            <center>
              <h3 style="font-family: Sarabun, sans-serif;">
                ขั้นตอน 4 : Reconcile
              </h3>
            </center>
            <br />
            <v-layout justify-center>
              <v-data-table
                :headers="headers"
                :items="data_rd_ewht"
                class="elevation-1 table-style"
                hide-actions
              >
                <template v-slot:items="props">
                  <tr>
                    <td class="text-xs-left">
                      {{ props.item.rd_ref }}
                    </td>

                    <td class="text-xs-center">
                      <div
                        v-if="
                          props.item.process == 'validated' &&
                            props.item.status == 'success'
                        "
                      >
                        <v-btn-toggle v-model="props.item.process">
                          <v-btn
                            @click="callEwht(props.item.rd_ref, 'success')"
                            class="btn-completed"
                            :value="'success'"
                            >Completed
                          </v-btn>
                          <v-btn
                            @click="callEwht(props.item.rd_ref, 'fail')"
                            class="btn-rejected"
                            :value="'fail'"
                            >Rejected
                          </v-btn>
                        </v-btn-toggle>
                      </div>

                      <div v-else>
                        <v-btn
                          v-if="props.item.process == 'success'"
                          class="btn-rejected"
                          disabled
                        >
                          Completed
                        </v-btn>
                        <v-btn
                          v-if="props.item.process == 'fail'"
                          class="btn-rejected"
                          disabled
                        >
                          Rejected
                        </v-btn>
                      </div>
                    </td>
                  </tr>
                </template>
              </v-data-table>
            </v-layout>
            <v-layout justify-center>
              <v-btn @click="submitEwhtCallback" class="btn-submit">
                Submit
              </v-btn>
            </v-layout>
          </v-container>
        </v-card>
      </v-flex>
    </v-layout>

    <v-footer>
      <span style="padding-left: 30px;font-family: Sarabun, sans-serif;"
        >© 2021 - ePayment Sandbox</span
      >
    </v-footer>
  </v-app>
</template>

<script>
import moment from "moment";
import Swal from "sweetalert2";

export default {
  data() {
    return {
      token: "",
      mobileView: false,
      headers: [
        { text: "หมายเลขรายการจ่ายเงิน", value: "order_id", sortable: false },
        {
          text: "สถานะ",
          value: "status_message",
          sortable: false,
          align: "center"
        }
      ],
      status_sandbox: this.$cookies.get("status_sandbox"),
      data_payment: [],
      data_rd_ewht: [],
      rd_result: []
    };
  },
  methods: {
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    async getSandboxRdEwht() {
      try {
        var { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/sendbox/rd/ewht`,
          {
            data: this.data_payment
          },
          {
            headers: { Authorization: this.token }
          }
        );

        if (data.status == "Success") {
          this.data_rd_ewht = data.data;
          // let i = 0;
          // if (this.data_rd_ewht.length > 0) {
          //   for (let index = 0; index < this.data_rd_ewht.length; index++) {
          //     const element = this.data_rd_ewht[index];

          //     if (
          //       element &&
          //       element.process == "reconciled" &&
          //       element.status == "success"
          //     ) {
          //       i = i + 1;
          //     }
          //     if (i == this.data_rd_ewht.length) {
          //       // this.$cookies.set("status_sandbox", "successful");

          //       Swal.fire({
          //         title: "ทดสอบสำเร็จแล้ว",
          //         text: "สามารถตรวจสอบได้ที่ หน้าประวัติการนำส่งภาษี",
          //         icon: "success"
          //       }).then(result => {
          //         close();
          //       });
          //     } else {
          //       this.$cookies.set("status_sandbox", "rd_ewht");
          //     }
          //   }
          // }
        } else {
          console.log(data);
        }
      } catch (error) {
        console.log(error.message);
      }
    },
    callEwht(_rd_ref, _status) {
      let _process = "";
      let _description = "";
      if (_status == "success") {
        _process = "reconciled";
        _description = "สำเร็จ";
      } else if (_status == "fail") {
        _process = "reconciled";
        _description = "ตรวจสอบเนื้อหาไม่ถูกต้อง";
      }

      let _data = {
        transaction_ref: _rd_ref,
        process: _process,
        status: _status,
        description: _description,
        transaction_date: moment(this.datetime).format("YYYYMMDD"),
        transaction_time: moment(this.datetime).format("HHmmss")
      };

      this.rd_result.push(_data);
    },
    async submitEwhtCallback() {
      let cksubmit = "";
      for (let index = 0; index < this.data_rd_ewht.length; index++) {
        const element = this.data_rd_ewht[index];

        if (
          element &&
          element.process == "validated" &&
          element.status == "success"
        ) {
          cksubmit = false;
          alert("กรุณาเลือกสถานะให้ครบ");
          break;
        }
      }

      if (cksubmit !== false) {
        try {
          var { data } = await this.axios.post(
            `${process.env.VUE_APP_APIHOST}/ewht/callback`,
            {
              rd_result: this.rd_result
            },
            {
              headers: { Authorization: this.token }
            }
          );
          if (data == "Success") {
            Swal.fire({
              title: "Completed",
              text: "",
              icon: "success",
              showConfirmButton: false,
              timer: 2500
            });
            setTimeout(() => {
              this.SandboxRDEwht(this.rd_result);
            }, 3000);
          }
        } catch (error) {
          console.log(error.message);
        }
      }
    },
    SandboxRDEwht(rd_result) {
      if (rd_result.length > 0) {
        if (rd_result.length == this.data_rd_ewht.length) {
          Swal.fire({
            title: "ทดสอบสำเร็จแล้ว",
            text: "สามารถตรวจสอบได้ที่ หน้าประวัติการนำส่งภาษี",
            icon: "success"
          }).then(result => {
            close();
          });
        }
      }
    }
  },
  created() {
    this.handleView();

    if (this.$route.query) {
      if (typeof this.$route.query.data == "string") {
        let _data = {
          rd_ref: this.$route.query.data
        };
        this.data_payment.push(_data);
      } else {
        for (let index = 0; index < this.$route.query.data.length; index++) {
          const element = this.$route.query.data[index];
          if (element) {
            let _data = {
              rd_ref: element
            };
            this.data_payment.push(_data);
          }
        }
      }
      this.getSandboxRdEwht();
    }
  }
};
</script>

<style scoped>
.btn-completed {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #58a144 !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #ecf8ea !important;
}

.btn-rejected {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #d1392b !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #fbe5e4 !important;
}

.btn-submit {
  margin-top: 30px;
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: white !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #58a144 !important;
  font-family: "Sarabun", sans-serif;
}
</style>
